module Derketo
  class EventTrace
    attr_accessor :first, :last, :length
    def initialize
      @first = nil
      @last = nil
      @length = 0
    end

    def push(event)
      if @first.nil?
        @first = event
      else
        event.previous = @last
        @last.next = event
      end
      @last = event
      @length += 1
    end

    def all
      @_events = []
      event = @first
      while event.nil? == false
        @_events << event
        event = event.next
      end
      @_events
    end

    def empty?
      @length == 0
    end
  end
end
